package nl.naturalis.oaipmh.server.util;

import jakarta.ws.rs.core.Response;
import nl.naturalis.oaipmh.api.OaiProtocolException;
import nl.naturalis.oaipmh.api.OaiRepository;
import nl.naturalis.oaipmh.api.OaiRequest;
import nl.naturalis.oaipmh.api.util.OaiWriter;
import org.openarchives.oai._2.OAIPMHtype;
import org.openarchives.oai._2.VerbType;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.io.ByteArrayOutputStream;

import static nl.naturalis.oaipmh.api.util.OaiUtil.createOAIPMHErrorResponse;
import static nl.naturalis.oaipmh.server.util.HttpResponses.*;
import static nl.naturalis.oaipmh.server.util.OaiServerUtil.*;
import static org.klojang.util.CollectionMethods.implode;
import static org.openarchives.oai._2.OAIPMHerrorcodeType.NO_RECORDS_MATCH;
import static org.openarchives.oai._2.VerbType.*;

/**
 * Executes the appropriate method on an {@link OaiRepository} depending on the
 * {@link OaiRequest}, and then forwards the response from the repository to the client.
 *
 * @author Ayco Holleman
 */
public class OaiRequestExecutor {

  private static final Logger logger = LoggerFactory.getLogger(OaiRequestExecutor.class);

  private final OaiRequest request;
  private final OaiRepository repo;
  private final String repoId;

  public OaiRequestExecutor(OaiRequest request,
        OaiRepository repository,
        String repoId) {
    this.request = request;
    this.repo = repository;
    this.repoId = repoId;
  }

  /**
   * Writes the OAI-PMH generated by the repository to the provided output stream.
   *
   * @return
   */
  public Response getResponse() {
    VerbType verb = request.getVerb();
    try {
      ByteArrayOutputStream out = new ByteArrayOutputStream(1024);
      if (verb == GET_RECORD) {
        repo.getRecord(out);
      } else if (verb == IDENTIFY) {
        repo.identify(out);
      } else if (verb == LIST_IDENTIFIERS) {
        repo.listIdentifiers(out);
      } else if (verb == LIST_METADATA_FORMATS) {
        repo.listMetaDataFormats(out);
      } else if (verb == LIST_RECORDS) {
        repo.listRecords(out);
      } else if (verb == LIST_SETS) {
        repo.listSets(out);
      }
      // This is a temporary hack. CRS currently harvests the entire medialib DB (!)
      // This causes a flood of mattermost messages that completely drowns out any message
      // from the geneious harvest. Once CRS starts harvesting the medialib with
      // decent "from" dates again, we should remove the "if" around the broadcastInfo
      // statement, and clean up the exception handling code as well.
      if (request.getVerb() == LIST_RECORDS
            && request.getResumptionToken() == null) {
        broadcastInfo("harvest complete");
      }
      return xmlResponse(out);
    } catch (OaiProtocolException e) {
      // Clients can in fact know that there are no more records to harvest _before_
      // they get the NO_RECORDS_MATCH error, but apparently that's how CRS likes to
      // terminate the harvest.
      if (e.getErrors().size() == 1 && e.getError().getCode() == NO_RECORDS_MATCH) {
        if (request.getResumptionToken() == null) {
          broadcastInfo("harvest complete (no new or updated records found)");
        } else {
          broadcastInfo("harvest complete");
        }
      } else {
        String msg = implode(e.getErrors(), x -> x.getValue(), "  ***  ", 0, -1);
        broadcastWarning(msg);
      }
      return oaipmhErrorResponse(request, e.getErrors());
    } catch (UnsupportedOperationException e) {
      broadcastError(e.getMessage());
      return notImplemented(e);
    } catch (Throwable t) {
      String msg = createErrorMessage(t, repoId, verb);
      broadcastError(msg);
      logger.error(msg, t);
      return serverError(t);
    }
  }

}
